<template>
  <div class="stock-daily-record" :style="{width}">
    <div v-if="displayOption" class="chart-option-block" :style="{opacity}" @click.stop="">
      <slot></slot>
    </div>
    <Row>
      <div class="stock-code inline-block">{{stockCode}}</div>
      <div class="record-block inline-block" :class="[todayStockData['priceChangeType']]">
        <Row :gutter="8">
          <i-col :lg="4" :md="12" :sm="12" :xs="12"  >
            <div>日期</div>
            <div>{{todayStockData['date']}}</div>
          </i-col>
          <i-col :lg="3" :md="12" :sm="12" :xs="12">
            <div>漲跌</div>
            <div>{{Number(todayStockData['priceChangeValue']).toFixed(2)}}</div>
          </i-col>
          <i-col :lg="3" :md="12" :sm="12" :xs="12">
            <div>開盤價</div>
            <div>{{todayStockData['openingPrice']}}</div>
          </i-col>
          <i-col :lg="3" :md="12" :sm="12" :xs="12">
            <div>最高價</div>
            <div>{{todayStockData['dailyMaxPrice']}}</div>
          </i-col>
          <i-col :lg="3" :md="12" :sm="12" :xs="12">
            <div>最低價</div>
            <div>{{todayStockData['dailyMinPrice']}}</div>
          </i-col>
          <i-col :lg="4" :md="12" :sm="12" :xs="12" class="closing-price-box">
            <div>收盤價</div>
            <div>{{todayStockData['closingPrice']}}</div>
          </i-col>
          <i-col :lg="3" :md="12" :sm="12" :xs="12">
            <div>成交量</div>
            <div>{{todayStockData['volume']}}</div>
          </i-col>
        </Row>
      </div>
      <div class="btn-block inline-block" @click.stop="displaySettingOptionAction">
        <div v-if="!disabled" class="setting-btn div-btn">
          <Icon type="md-settings"></Icon>
        </div>
      </div>
    </Row>
  </div>
</template>

<script>
  const actions = {
    displaySettingOptionAction(stockCode, forceHidden = false) {
      const toHide = this.displayOption || forceHidden;
      if (toHide) {
        this.opacity = 0;
        setTimeout(() => {
          this.displayOption = false;
        }, 10);

      } else {
        this.displayOption = true;
        setTimeout(() => {
          this.opacity = 1;
        }, 1);
      }
    },
  };

  export default {
    name: "StockDailyRecord",
    props: {
      stockCode: { required: true },
      data: { type: Object, required: true },
      width: { type: String, default: '100%' },
      syncPoint: { default: undefined },
      disabled: { type: Boolean, default: false },
    },
    data() {
      return {
        displayOption: false,
        opacity: 0,
      };
    },
    computed: {
      dataKeys() {
        return Object.keys(this.data).sort();
      },
      todayStockData() {
        const hasPoint = this.syncPoint && this.syncPoint['key'];
        const key = (hasPoint)
          ? this.syncPoint['key']
          : this.dataKeys.slice(-1)[0];
        return this.data[key];
      }
    },
    methods: {
      ...actions,
    },
  }
</script>

<style lang="scss" scoped>
  @import "../../assets/css/mixin";

  .stock-daily-record {
    background-color: rgba(28, 36, 52, 0.5);
    border-radius: 8px;
    margin: 0 0 10px 0;
    .chart-option-block {
      position: absolute;
      top: 70px;
      right: 30px;
      width: 60%;
      padding: 15px;
      border-radius: 6px;
      z-index: 99999;
      text-align: left;
      transition: opacity linear 0.3s;
    }
    .stock-code {
      width: 70px;
      font-size: 20px;
      font-weight: bold;
    }
    .record-block {
      text-align: center;
      width: calc(100% - 100px - 70px);
      min-height: 60px;
      padding: 10px 20px;
      font-size: 14px;
      font-weight: bolder;
      .closing-price-box {
        border-radius: 4px;
      }
    }
    .btn-block {
      width: 60px;
      .setting-btn {
        @include circle-div-btn(30);
      }
    }
  }
</style>
